#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <GL/glut.h>
#include <math.h>
#include "obj.h"

int draw_obj( struct MotionTree *tree, int level )
{
  int i ;
  GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
  GLfloat mat_ambient[] = { 0.2,0.2,0.2,1.0 } ;
    
  mat_diffuse[0]=mat_diffuse[0]- ( level&1)    *0.3 ;
  mat_diffuse[1]=mat_diffuse[1]- ((level&2)>>1)*0.3 ;
  mat_diffuse[2]=mat_diffuse[2]- ((level&4)>>2)*0.3 ;
  
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glLightfv(GL_LIGHT0, GL_AMBIENT, mat_ambient ) ;

  glTranslated( tree->Mt.p.x, tree->Mt.p.y, tree->Mt.p.z ) ;
  glRotated(tree->Mt.r.x, 1.0, 0.0, 0.0);
  glRotated(tree->Mt.r.y, 0.0, 1.0, 0.0);
  glRotated(tree->Mt.r.z, 0.0, 0.0, 1.0);
    
  if( tree->Mt.obj_id>=0 ){
    GLdouble vertex[3] ;
    struct Face3D *flist ;
    int            fnum  ;
    struct Vec3D  *plist ;
    
    glBegin( GL_TRIANGLES ) ;
    flist=POlist.Obj[tree->Mt.obj_id]->flist ;
    fnum =POlist.Obj[tree->Mt.obj_id]->fnum  ;
    plist=POlist.Obj[tree->Mt.obj_id]->plist ;
    
    for( i=0 ; i<fnum ; i++ ){
      glColor3f(1.0, 1.0, 1.0);
      vertex[0]=flist[i].normal.x ;
      vertex[1]=flist[i].normal.y ;
      vertex[2]=flist[i].normal.z ;
      glNormal3dv(vertex);
      vertex[0]=plist[flist[i].p2].x ;
      vertex[1]=plist[flist[i].p2].y ;
      vertex[2]=plist[flist[i].p2].z ;
      glVertex3dv(vertex);
      vertex[0]=plist[flist[i].p1].x ;
      vertex[1]=plist[flist[i].p1].y ;
      vertex[2]=plist[flist[i].p1].z ;
      glVertex3dv(vertex);
      vertex[0]=plist[flist[i].p0].x ;
      vertex[1]=plist[flist[i].p0].y ;
      vertex[2]=plist[flist[i].p0].z ;
      glVertex3dv(vertex);
    }
    glEnd();
  }

  for( i=0 ; i<tree->num ; i++ ){
    glPushMatrix();
    draw_obj( tree->node[i], level+1 ) ;
    glPopMatrix();
  }
  
  return(0) ;
}
