%{
/***
 ***  lex for m-design
 ***/
#include <stdlib.h>
#include <stdio.h>

#define STRSIZE  65535
char str[STRSIZE+1] ;
int  strp ;

int yylineno=1 ;

//#include "oprator.h"

%}

%start   STRING COMM

%%
<INITIAL>"{"			return('{') ;
<INITIAL>"}"			return('}') ;
<INITIAL>"("			return('(') ;
<INITIAL>")"			return(')') ;
<INITIAL>"<"			return('<') ;
<INITIAL>">"			return('>') ;
<INITIAL>"="			return('=') ;
<INITIAL>","			return(',') ;
<INITIAL>";"			return(';') ;

<INITIAL>[-|+|]{0,1}[0-9]+\.[0-9]+	{
					  yylval.num=atof(yytext) ;
					  return(NUM) ;
					}
<INITIAL>[-|+|]{0,1}[0-9]+	{
				  yylval.num=atoi(yytext) ;
				  return(NUM) ;
				}
<INITIAL>"obj"			return(OBJ) ;
<INITIAL>"file"			return(FLE);
<INITIAL>"pos"			return(POS) ;
<INITIAL>"rot"			return(ROT) ;

<INITIAL>"#"			BEGIN COMM ;

<COMM>.				;
<COMM>"\n"			{
				  yylineno++ ;
				  BEGIN INITIAL ;
				}

<INITIAL>\"			{
				  strp=0 ;
				  BEGIN STRING ;
				}

<STRING>\\\"			{
				  if( strp<=STRSIZE ){
				    str[strp++]='"' ;
				  }
				}

<STRING>\"			{
				  if( strp>=STRSIZE ){
				    fprintf(stderr,"string too long") ;
				    yylval.str=NULL ;
				  }else{
				    str[strp]='\0' ;
				    yylval.str=str ;
				  }
				  BEGIN INITIAL ;
				  return(STR) ;
				}

<STRING>.           		{
				  if( strp<=STRSIZE ){
				    str[strp++]=yytext[0] ;
				  }
				}

<INITIAL>[ \t\r]			;
<INITIAL>[\n]			{
				  yylineno++ ;
				}
<INITIAL>[a-zA-Z0-9]+		{
				  return(SYNERR) ;
				}
<INITIAL>.			{
				  return(CHRERR) ;
				}

%%

