#include "vector.h"

/**************************************/
/* F^                               */
/**************************************/
typedef float objRGBA[4] ;

/**************************************/
/* (Op`|S)\           */
/**************************************/
struct Face3D{
  int p0,p1,p2        ; /** _XgID         **/
  int id              ; /** tpIuWFNgID **/
  struct Vec3D normal ; /** ʖ@                 **/
  objRGBA ambient     ; /**  F              **/
  objRGBA diffuse     ; /** ̂̐F               **/
  objRGBA specular    ; /** nCCgF           **/
  float   shininess   ;
} ;


/**************************************/
/* r[\                       */
/**************************************/
struct View3D{
  double         fov     ; /** p               **/
  struct Vec3D   v       ; /** Jʒu           **/
  struct Vec3D   c       ; /** ړ_               **/
  struct Vec3D   u       ; /** VxNg         **/
  struct Vec3D   r       ; /** ]px             **/
  struct Vec3D   p       ; /** pxNg         **/
  struct Vec3D   cur     ; /** OJ[\ʒu   **/
  struct Vec3D   sta     ; /** OJ[\[N **/
  int            win_w   ; /** ECh           **/
  int            win_h   ; /** ECh         **/
  double         scale   ; /** _ړʕ␳       **/
} ;
  

/**************************************/
/* |SIuWFNg\         */
/**************************************/
struct PolyObjData{
  double drawx,drawy,drawz ; /** `ʒu       **/
  double px,py,pz          ; /** ʒu           **/
  double ox,oy,oz          ; /** ]p         **/
  int            pnum      ; /** _         **/
  struct Vec3D  *plist     ; /** _Xg     **/
  struct Vec3D  *nlist     ; /** _@Xg **/
  int           *draw      ; /** _\[N **/
  int            fnum      ; /** ʐ           **/
  struct Face3D *flist     ; /** ʃXg       **/
  char          *fname     ; /** 3DSt@C **/
  struct MotionTree *node  ; /** tpnode   **/
} ;


/**************************************/
/* |SIuWFNgXg\   */
/**************************************/
#define MAX_POLYOBJ_NUM   (64)
struct PolyObjList{
  struct PolyObjData *Obj[MAX_POLYOBJ_NUM] ;
  int                 num ;
} ;

struct PolyObjList POlist ;


/**************************************/
/* [VIuWFNg\       */
/**************************************/
struct MotionObjData{
  struct Vec3D p ;
  struct Vec3D r ;
  int          obj_id ;
} ;


/**************************************/
/* [VIuWFNgc[\ */
/**************************************/
#define MAX_CHILD_NUM   (64)
struct MotionTree{
  struct MotionObjData   Mt ;
  struct MotionTree     *node[MAX_CHILD_NUM] ;
  int                    num ;
} ;

struct MotionTree        M_tree ;
  

struct Node{
  struct MotionTree *node ;
  double             d ;
} ;


/**************************************/
int InitMtNode( struct MotionTree *root ) ;
int AllocChildMtNode( int nest_depth ) ;
int SetPolyOBJMtNode( int nest_depth, struct PolyObjList *polist, int id ) ;
int SetPOSMtNode( int nest_depth, struct Vec3D pos ) ;
int SetROTMtNode( int nest_depth, struct Vec3D rot ) ;
int SetENDMtNode( int nest_depth ) ;
int DumpMtNode( FILE *ofp, struct MotionTree *tree, int level ) ;
int AllFreeMtNode( struct MotionTree *tree ) ;

struct PolyObjData *read_3ds( char *fname, int id ) ;
int InitPolyObjList( struct PolyObjList *polist ) ;
int AddPolyObjList( struct PolyObjList *polist, char *fname ) ;

int search_node( struct View3D view,  struct MotionTree *tree, struct Node *Nd ) ;
int view_set( struct View3D *view ) ;
