%{
#include <stdlib.h>
#include <stdio.h>
#include "obj.h"

#define MAX_NEST_DEPTH (64)
int nest_depth =0 ;
int obj_no     =0 ;
int parent_tree[MAX_NEST_DEPTH] ;
int yyerrors   =0 ;
%}
  
%union{
  double        num ;
  char         *str  ;
}

%token OBJ
%token FLE
%token POS
%token ROT
%token <num> NUM
%token <str> STR

%token SYNERR
%token CHRERR

%token '{'
%token '}'
%token '('
%token ')'
%token ';'
%token ','

%%

obj_list
	: /*empty*/
	| obj_list  object
        ;

object
	: OBJ '{'
          {
	    if( nest_depth<MAX_NEST_DEPTH ){
	      int ret ;
	      ret=AllocChildMtNode( nest_depth ) ;
	      if( ret<0 ){
	        yyerror( "object read faild." ) ;
	        YYERROR ;
	      }
 	      parent_tree[nest_depth]=obj_no ; nest_depth++; obj_no++ ;
	    }else{
	      yyerror( "object struct is too depth" ) ;
	      YYERROR ;
	    }
	  }
          param_list obj_list  '}'
	  {
	    nest_depth-- ;
	    SetENDMtNode( nest_depth ) ;
	  }
        ;

param_list
	: /*empty*/
	| param_list Param
	;

Param
	: FLE '=' STR ';'
	  {
	    int ret ;
	    ret=AddPolyObjList( &POlist, $3 ) ;
	    if( ret<0 ){
	      yyerror( "3DS file read faild." ) ;
	      YYERROR ;
	    }
	    SetPolyOBJMtNode( nest_depth-1, &POlist, ret ) ;
	  }

	| POS '=' '<' NUM ',' NUM ',' NUM '>' ';'
	  {
	    struct Vec3D pos ;
	    pos.x=$4 ;
	    pos.y=$6 ;
	    pos.z=$8 ;
	    SetPOSMtNode( nest_depth-1,pos ) ;
	  }

	| ROT '=' '<' NUM ',' NUM ',' NUM '>' ';'
	  {
	    struct Vec3D rot ;
	    rot.x=$4 ;
	    rot.y=$6 ;
	    rot.z=$8 ;
	    while(-1){
	      if( rot.x>= 360.0 ){ rot.x+=-360.0; }
	      if( rot.x<=-360.0 ){ rot.x+= 360.0; }
	      if( rot.x<360.0 && rot.x>=0.0 ) break ;
	    }
	    while(-1){
	      if( rot.y>= 360.0 ){ rot.y+=-360.0; }
	      if( rot.y<=-360.0 ){ rot.y+= 360.0; }
	      if( rot.y<360.0 && rot.y>=0.0 ) break ;
	    }
	    while(-1){
	      if( rot.z>= 360.0 ){ rot.z+=-360.0; }
	      if( rot.z<=-360.0 ){ rot.z+= 360.0; }
	      if( rot.z<360.0 && rot.z>=0.0 ) break ;
	    }
	    SetROTMtNode( nest_depth-1,rot ) ;
	  }
	;

%%

int yyerror(char *s)
{
  extern int yylineno;
  fprintf(stderr, "%d: %s\n", yylineno, s) ;
  yyerrors++ ;
  return(0) ;
}


#include "lex.yy.c"
